// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/

var x : Number = 42 on replace { println("x changed"); };
var y : String = "Test" on replace oldY { println("old y: {oldY}, new y: {y}"); }
var integers : Integer[] = [] on replace oldValues[lo..hi] = newValues {
    println("lo: {lo}, hi: {hi}, old: {oldValues}, new: {newValues}, res: {integers}");
}

x = 23;
y = "JavaFX Rules";

println("\n unidirectional binding");

var myX : Number = bind x;
println("x: {x}, myX: {myX}");

x = 42;
println("x: {x}, myX: {myX}");


println("\n bidirectional binding");

var myY : String = bind y with inverse;
println("y: {y}, myY: {myY}");

y = "Java is SUN";
println("y: {y}, myY: {myY}");

myY = "SUN is Java";
println("y: {y}, myY: {myY}");


println("\n sequence binding");

integers[0] = 1;
integers[0] = 0;
insert [1, 2, 0] into integers;
delete integers[0..2];
integers[3] = 9;
insert [1, 2, 3] before integers[1];
insert [4, 5, 6] after integers[3];
